#!/bin/sh

# Make a tree with 50 leaves based on
# the training file data/train_dat.asc
# and the pruning file data/prune_dat.asc.
# The tree will be written to the file tree_info.
# Furthermore, tree_info_Evar will contain the expected
# conditional prediction variance of the predicted vector y.
#
# Note, that if you run this multiple times, 
# you can obtain different numbers of clusters
# based on the randomseed you started with (used for the
# initial vector quantization of the leaves)
#
# For this example the input vector x used for prediction
# has 8 components and the predicted vector y has 3
# components 

make_agtree -p data/prune_dat.asc -l 50 data/train_dat.asc tree_info


# Now take the data in data/test_dat consisting of 8 component
# vectors, and use the tree to obtain the predicted y vectors.
# The output will be written to the file 'predicted_data' 

predict tree_info data/test_dat predicted_data


