#ifndef INC_AGT_TREE
#define INC_AGT_TREE


#define LEAF 1
#define NOT_A_LEAF 0

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../ansi_lib_loc/allocate.h"
#include "../include/agtree.h"
#include "../include/agt_clust.h"

/* routine determine_node does NOT account for pruning, but rather
   runs to top of tree. Should not be used by regular user */
int determine_node(double *xvec, int x_len, struct node *clust, struct cmds *params);


int calc_nb_nodes(struct node *clust, struct cmds *params);
void check_full_tree(struct node *clust, struct cmds *params);
void printTree(struct node *clust, struct cmds *params);
void printNode(int node,struct node* clust);

/* Following routines are implemented in agt_tree.c but exported in
   agtree.h, thus commented out here */
/*int classify_xvec(double *xvec, int x_len, struct node *clust, struct cmds *params);*/

#endif
