#include "../include/agt_calcerr.h"

void compute_all_prederrs_man(struct node *clust, struct data *train, struct cmds *params)
{
  int nb_points,nb_clusters,x_len, y_len;
  double y_hat_j;
  int i,j,cl,k;

  nb_clusters = params->nb_clusters;
  nb_points=train->nb_points;
  x_len = train->x_len; 
  y_len = train->y_len; 
  

  /* clear old pred_err */
  for (cl=0;cl<params->nb_nodes;cl++)
    clust[cl].pred_err=0.0;


  for (i=0;i<nb_points;i++)
    {
      /* this needs to be cluster, NOT node !!! */
      cl=determine_cluster(train->data[i], x_len, clust, params);
      
      /* now that we have leaf for this data point, we run up the 
	 tree and compute mse for each node on the way up to the root 
      */
      for (;;)
	{
	  /* compute error for j'th component for current cluster cl */
	  for (j=0;j<y_len;j++)
	    {
	      y_hat_j = 0.0;
	      for (k=0;k<x_len;k++)
		y_hat_j += (train->data[i][k] * clust[cl].a[k][j]);
	      

	      y_hat_j += clust[cl].b[j];

	      /* Now add to pred_err */
	      clust[cl].pred_err += ((y_hat_j - train->data[i][j+x_len])*(y_hat_j - train->data[i][j+x_len]));
	    }


	  /* now go to parent or exit if this is root */
	  if (clust[cl].parent ==-1)
	    break;
	  else
	    cl=clust[cl].parent;
	} /* end forever */
    } /* end for i */

}
 

