#include "../include/agt_matrixutils.h"
 




double** matrix_prod(double **a, int a_rows, int a_cols, double **b, int b_rows, int b_cols, int *out_rows, int *out_cols)
{
  int r_rows, r_cols;
  int i,j,k;
  double **result;

  if (a_cols!=b_rows)
    {
      fprintf(stderr,"Error in matrix_prod: a_cols=%d != %d=b_rows\n\a\n",a_cols,b_rows);
      exit(-1);
    }

  r_rows=a_rows;
  r_cols=b_cols;

  result=(double**)multialloc(sizeof(double),2,r_rows,r_cols);
  
  for (i=0;i<r_rows;i++)
    for (j=0;j<r_cols;j++)
      result[i][j]=0.0;
  
  for (i=0;i<r_rows;i++)
    for (j=0;j<r_cols;j++)
      for (k=0;k<a_cols;k++)
	result[i][j] += (a[i][k]*b[k][j]);
  
  *out_rows=r_rows;
  *out_cols=r_cols;
  
  return(result);
  
}


double** matrix_trans(double **in, int rows, int cols)
{
  int i,j;
  double **out;

  out=(double**)multialloc(sizeof(double),2,cols,rows);
  
  for (i=0;i<rows;i++)
    for (j=0;j<cols;j++)
      out[j][i]=in[i][j];

  return(out);
}

double matrix_trace(double **in, int rows, int cols)
{
  double tr=0.0;
  int i;
  
  if (rows!=cols)
    {
      fprintf(stderr,"Error in matrix_trace: rows!=cols\n\a\n");
      exit(-1);
    }

  for (i=0;i<rows;i++)
    tr += in[i][i];

  return(tr);
}
  




