#include "../include/agt_var.h"




void CalcClustVar(struct node *clust,struct data *train, struct cmds *params)
{
  int nb_points,nb_nodes,x_len, y_len;
  int i,j,cl,c,k;
  double y_hat_j,nbp_dbl;
  double *er;

  nb_nodes = params->nb_nodes;
  nb_points=train->nb_points;
  x_len = train->x_len; 
  y_len = train->y_len; 
  

  er=(double*)get_spc(y_len,sizeof(double));

  
  for (c=0;c<nb_nodes;c++)
    {
      clust[c].nb_points=0;

    }
  
  for (c=0;c<nb_nodes;c++)
    for (k=0;k<y_len;k++)
      for (j=0;j<y_len;j++)
	clust[c].yer2[k][j] = 0.0;

  for (i=0;i<nb_points;i++)
    {
      cl=classify_xvec(train->data[i], x_len, clust, params);
      clust[cl].nb_points++;
      for (j=0;j<y_len;j++)
	{
	  y_hat_j=0;
	  for (k=0;k<x_len;k++)
	    y_hat_j +=(train->data[i][k]  * clust[cl].a[k][j]);  

	  y_hat_j += clust[cl].b[j];
    
	  er[j] = y_hat_j - train->data[i][j+x_len];
	}

      for (k=0;k<y_len;k++)
	for (j=0;j<y_len;j++)
	  clust[cl].yer2[k][j] += (er[k]*er[j]);


    }
  
	

  for (c=0;c<nb_nodes;c++)
    if (clust[c].nb_points > 0)
      {
	nbp_dbl=(double)clust[c].nb_points;
	for (k=0;k<y_len;k++)
	  for (j=0;j<y_len;j++) 
	    clust[c].yer2[k][j] /= nbp_dbl;
      }

 


  free((void*)er);


}


void compute_and_write_E_cond_var(struct node *clust, struct cmds *params, int y_len)
{
  int nb_nonzero_clusters=0;
  int c,nb_nodes,k,j;
  double nbp_dbl,total_points_dbl=0.0;
  FILE *fp;
  double **Evar;
  char fname[256];

  nb_nodes = params->nb_nodes;

  Evar=(double**)multialloc(sizeof(double),2,y_len,y_len);
  for (k=0;k<y_len;k++)
    for (j=0;j<y_len;j++) 
      Evar[k][j] = 0.0;
 
  for (c=0;c<nb_nodes;c++)
    if (clust[c].nb_points > 0)
      {
	nb_nonzero_clusters++;
	nbp_dbl=(double)clust[c].nb_points;
	total_points_dbl += nbp_dbl;

	for (k=0;k<y_len;k++)
	  for (j=0;j<y_len;j++) 
	    Evar[k][j] = Evar[k][j] + clust[c].yer2[k][j] * nbp_dbl;
      }
  
  for (k=0;k<y_len;k++)
    for (j=0;j<y_len;j++) 
      Evar[k][j] /= total_points_dbl; 
  


  /* PRINT OUTPUT */

  /*printf("Total points=%1.1f, non-empty nodes=%d\nEvar=\n",total_points_dbl,nb_nonzero_clusters);*/
  printf("Expected conditional covariance of wavelet coefficients:\n");
  for (k=0;k<y_len;k++)
    {
      for (j=0;j<y_len;j++) 
	printf("%1.2g  ",Evar[k][j]);
      printf("\n");
    }
  printf("\n");



  /* WRITE EVAR TO FILE */
  sprintf(fname,"%s_Evar",params->outfile);
  
  printf("Writing to file %s\n",fname);
  fp=fopen(fname,"w");
  if (fp==NULL)
    {
      fprintf(stderr,"Error: Can't open file %s for writing\n\a\n",fname);
      exit(-1);
    }

  for (k=0;k<y_len;k++)
    {
      for (j=0;j<y_len;j++) 
	fprintf(fp,"%1.20g  ",Evar[k][j]);
      fprintf(fp,"\n");
    }
  fclose(fp);





  
  /* FREE MEMORY */
  multifree((void*)Evar,2);

}













