#!/bin/sh

# This example reconstructs the projection data in data/mri_sino_m.mat
# which was generated from the image data/mri_truth_m.mat by noisy
# forward projection.
# The overall regularization factor is set to 1.0 (-s 1.0)
# and the weight of the expected conditional variances is 
# set to 0.0 (-w 0.0).
# The number of iterations performed at the finest scale are 10 (-i 10).
# The program reads the mask specifying the spatial support
# of the reconstructed object from EXAMPLE/data/mri_mask_m.mat.
#
# The output is written to the file mri_recon_wdw3.mat in this (EXAMPLE) directory.


cd ..
bin/tomo -s 1.0 -w 0.0 -i 10 EXAMPLE/data/mri_sino_m.mat  EXAMPLE/data/mri_mask_m.mat EXAMPLE/mri_recon_ex1.mat


