#ifndef INC_IOMAT_DBL

#define INC_IOMAT_DBL

#include <mat.h>
#include <stdarg.h>
#include <matrix.h>

int write_mat_double_image(
  double **img,        /* 2-D image of size img[ht][wd] */
  int   ht,           /* height of image */
  int   wd,           /* width of image */
  char  *matrix_name, /* name of matlab matrix */
  MATFile *fout       /* matlab mat file pointer */
  );

int write_mat_double_image_cor(
  double **img,        /* 2-D image of size img[ht][wd] */
  int   ht,           /* height of image */
  int   wd,           /* width of image */
  char  *matrix_name, /* name of matlab matrix */
  MATFile *fout       /* matlab mat file pointer */
  );

double **read_mat_double_image(
/* Returns pointer to 2-D image of size img[ht][wd] */
  int   *ht,           /* height of image */
  int   *wd,           /* width of image */
  char  *matrix_name,  /* name of matlab matrix */
  MATFile *fin         /* pointer to file */
  );


#endif
