#include "quicksort.h"

/* #define PRINT */

void swap_entry(struct entry *entry1,struct entry *entry2)
{
 int helpi;
 double helpd;

 helpd=entry1->value;
 helpi=entry1->index;

 entry1->value=entry2->value;
 entry1->index=entry2->index;

 entry2->value=helpd;
 entry2->index=helpi;
}


void quicksort(struct entry *array,int length)
{
 int length1,length2;
 if (length>1)
   {
     partition(&length1,&length2,array,length);
     quicksort(array,length1);
     quicksort(array+length1,length2);
   }
}

void partition(int *length1,int *length2,struct entry *A,int length)
{
  int i,j;
  double x;


  i=-1;
  j=length;

  x=A[0].value; /* pivot */

  while (i<j)
    {
      i++;
      while (A[i].value < x)
	i++;
      j--;
      while (A[j].value > x)
	j--;
      if (i<j)
	swap_entry(&A[i],&A[j]);
    }
  *length1=j+1;
  *length2=length-(j+1);

}

/* The following void main is only for empirical testing of quicksort...*/
/* in order to use it, please include randlib.h and modify Makefile.*/


/*
void main(int argc,char **argv)
{
  struct entry array[1000];
  int length=1000,i;

  srandom2(1);
  readseed();

  for (i=0;i<length;i++)
    {
     array[i].value=random2();
     array[i].index=i;
    }

  writeseed();

#ifdef PRINT
  for (i=0;i<length;i++)
    printf("%f \n",array[i].value);
#endif

  quicksort(array,length);

#ifdef PRINT
  printf("\n\nRESULT:\n");
#endif

  for (i=0;i<length;i++)
   {
#ifdef PRINT
    printf("%1.5f  %d\n",array[i].value,array[i].index);
#endif
    if (i>0)
     if (array[i].value<array[i-1].value)
       {
        fprintf(stderr,"***ERROR***");
        exit(-1);
       }
    }
  
}      
*/ 
