#ifndef TOMO_DEFS_INCLUDED
#define TOMO_DEFS_INCLUDED

#include "../ansi_lib_loc/A_comp_dbl_storeflt.h"


#define PYR_LEVELS 5
#define WINDOW_SIZE 3


struct cmdline_params{
  char *input;
  char attenuation[255];
  char ground_truth[255];
  int no_iter_rec;
  int resol;
  char *output;
  
  double rel_Ecvar;
  double w_reg;
  double fov; /* in mm */

  char *mask_file;
  int mask_FLAG;
  int groundtr_FLAG;
  int attn_FLAG;
  int fov_FLAG;
  int diagoutput_FLAG;

}; 

struct all_data{  /* all data except transmission attenuation sino */
  double ****Z,***Xall; /* wavelet and scaling coeffs at all scales */
  double **Y; /* sinogram counts */
  int ***mask;
  double scatter;
  struct sino_info sino;
  double ****allprior_params;
};


struct ground_truth{
  double ****Z_true;
  double ***X_true;
};



struct wavICMdata{  /* parameters computed during wavelet ICM */
  /*double theta[3];*/  /* vector of first derivatives for each wav-coeff for
		      log likelihood ftn only */
  /*double B[3][3];*/   /* matrix of second derivatives for 
		      log-likelihood ftn only */ 
  
  double V[3];      /* the 3 wavelet coeffs under question, old values */
  double prior_mean[3];
  double prior_icov[3][3]; /* INVERSE prior covariance matrix */

  double D1,D2;
  double pri1,pri2;
  double alpha;


};





struct cluster_info{
  struct node *clust[PYR_LEVELS-1];
  int X_len;
  int Y_len;
  int nb_clusters[PYR_LEVELS-1];
  int nb_nodes[PYR_LEVELS-1];
  int ***cluster_map;
  double stat_var[PYR_LEVELS-1][3][3];
};


struct cfg_info{
  int no_sino;
  char **sino_fname;
  char nrm_file[256];
  char mask_file[256];
  double fov;
  int resol;
  int no_iter_rec;
  double p;
  double sigma;
  int no_iter_param;
  int analyt_FLAG;
  char sysres_fname[256];
  int addposi_FLAG;

  int attn_MODE;
  double attn_circ_rad;
  double attn_cnst;
  char attn_fname[256];

  int decay_FLAG;
  double prj_max_t;
  double scatter;
  int deadtime_FLAG;
  int verbose;
  int MATLAB_FLAG;
  int NRM_FLAG;
  int plane;
  char initial[256];
  int SUP_FLAG;
  int INTERP_FLAG;
  char output[256];
  int mask_FLAG;


  double rel_Ecvar;
  double w_reg;
  int groundtr_FLAG;
};

#endif
