function mask = support(img,m,t)

%  mask = support(img,m)
%  img - CBP image
%  m - controls the no. of erosion and dilation operations.
%       It is set to 3 if it is not supplied.
%  t - threshold to compute the binary image.  
%      It is set to zero if it is not supplied.
%  mask - binary image corresponding to support of object

if nargin<2
m = 3;
end

if nargin<3
t = 0;
end

mask = img>t;
mask = erode(mask,'erode',m);
mask = dilate(mask,'dilate',2*m);
mask = erode(mask,'erode',m);
